#include <stdio.h>
#include <math.h>
#include "q12.dat"                             // if your want "hanzi"
#include "jfc.c"                               // main lib.
#define nn 8640*8200
#define mm 2048*2048
int  n512;                        // 512 -- 1250
FILE *fp;
unsigned char a[mm],d[128*128], h[72][80],hh[36][80];
float aa[mm],ab[mm];
float b[nn];                      // ibit=-3
  float bb[nn];
float dd[128*128];
short b2[nn];                     // ibit= 16
unsigned char b1[nn];             // ibit= 8
int   n1,n2,ibit,m0,m1,m2;
float sky,sig,see,expt;
char  color;
int   it=0;                       // ! print more
int   vv;                         // ==n1/m1
int   m3=0;                       // frame size changed
float gg;                         // gray
int   le,mi,lm;                   // left_turn & mirror_turn counter,
int   ia8,type;                   // if exit A8, if BOK
int   i36=130;                    // frame top space lines
int   is;                         // pick out star number
int   X,Y;                        // cursor at position on b[n2][n1];
double a8[8],b8[8], cx,cy,pi;
double xx,yy,a1,d1;
char  u1[80],u2[80],u3[80],u4[80],u5[80],u6[80],u7[80],u8[80];
char                       v4[80],v5[80],v6[80],v7[80],v8[80];
char  c1[14],c2[14];
int   SL,U4;
char  t[80];
// u1: filename. n1*n2
// u2: sky,rms, seeing,expt. 
// u3: center
// u4: pick_out star
// u5: ucac4 mag type ra dec
// u6: sdss rmag type ra dec 
// u7: sdss_num, umag, gmag
// u8: cursor X,Y,Value ra,dec
int itt=0;
int tt[7]={90,180,270,-90,-180,-270,-360};

main(int ac, char **av)
{
  int ip,i,j,k,kk, i1,j1, oi,oj, oldi,oldj;
  float x,y;
  unsigned char f1[80],c4[4],c;
  pi=4.*atan(1.0); cx=pi/12.; cy=pi/180.;

  if(ac<2){ printf("\n\t **** show ccd fits images **** 20150104 jiang\n");
            help(); exit(0); }
  strcpy(f1,av[1]); k=strlen(f1);
  for(i=0;i<k;i++)if(f1[i]=='*')break;
  if(k!=i){ printf("No fits_files be found!!\n"); exit(0); }
  n512=512; 
l00:
  c=av[ac-1][0];
  if(c=='!'){ it=1; ac--; goto l00; }
  if(c=='%'){  ac--; sscanf(&av[ac][1],"%d",&n512); goto l00; }
  if(ac>2)for(i=1;i<ac;i++)printf("%3d: %s\n",i,av[i]);
  if(n512>1024)n512=1024;

  ip=1;
loop:
  le=mi=0;
    strcpy(f1,av[ip]);
    fp=fopen(f1,"rb");  if(!fp){ printf("%s not found !\n",f1); exit(0); }
    fread(h,36,80,fp); 
    sscanf(&h[1][23],"%d",&ibit);
    sscanf(&h[3][23],"%d",&n1);  
    sscanf(&h[4][23],"%d",&n2); 
    if(n1*n2>nn){
      fclose(fp); printf("%3d: %s *** is too bigger!\n",ip,f1); 
      ip++; if(ip>=ac)exit(0);
      goto loop; 
    } 
    k=indexpos(h,"END     ",36); kk=36;
    if(k==36){ fread(&h[36],36,80,fp); kk=72; }
    k=indexpos(h,"END     ",kk); 
    while(k==36 || k==72){ fread(hh,36,80,fp); k=indexpos(hh,"END     ",36); }

    k=indexpos(h,"SEEING  ",kk);    see=0;
    if(k!=kk)sscanf(&h[k][20],"%f",&see); 
    k=indexpos(h,"EXPTIME ",kk);    expt=0;
    if(k==kk)k=indexpos(h,"EXPOSURE",kk);
    if(k!=kk)sscanf(&h[k][20],"%f",&expt); 

    k=indexpos(h,"A81     ",kk);  ia8=0;
    if(k!=kk){         type=1;    ia8=1;
      for(i=0;i<8;i++)sscanf(&h[k+i][10],"%le",&a8[i]);
      xytoad(a8,b8);
      if(b8[4]<0. || b8[5]<0.)type=2;
      if(b8[4]>n1 || b8[5]>n2)type=2;
      xx=n2/2.; yy=n2/2.;
      xy_rad(a8[6],a8[7],xx,yy,&a1,&d1,type,0);
      toms2(a1,c1,1); toms2(d1,c2,0);
    }

    if(ibit==-32){ fread(b,n1*n2,4,fp); swap4(b,n1*n2*4); }
    if(ibit==16){ fread(b2,n1*n2,2,fp); swap2(b2,n1*n2*2);
                  for(k=0;k<n2*n1;k++)b[k]=b2[k]+32768; }
    if(ibit==8){ fread(b1,n1*n2,1,fp); for(k=0;k<n2*n1;k++)b[k]=b1[k]; }
    fclose(fp);
    strcpy(t,f1); for(i=strlen(t)-1;i>0;i--)if(t[i]=='/')break; if(i)i++; 
    strcpy(f1,&t[i]);
  
l05:
    getsky(b,n1,n1/2,n2/2,&sky,&sig);
    if(sky+sig<2.1){ for(i=0;i<n1*n2;i++)b[i]*=1000.; goto l05; }  //flat
    vv=n1/n512; if(vv==0)vv=1;
for(i=0;i<n1*n2;i++)bb[i]=b[i];
l051:
    m1=n1/vv; m2=n2/vv; 
    if(m1*vv!=n1)m1++; if(m2*vv!=n2)m2++;
    if(m1>1250){ vv++; goto l051; }
    for(j=k=0;j<n2;j+=vv)for(i=0;i<n1;i+=vv){ x=0.;
      for(j1=j;j1<j+vv;j1++)for(i1=i;i1<i+vv;i1++)x+=b[j1*n1+i1]-sky;
      x/=vv*vv; aa[k++]=x;
    }
    if(ac==2)sprintf(u1,"  %s %d*%d %d",   f1,n1,n2,vv);
    else     sprintf(u1,"%d: %s %d*%d %d",ip,f1,n1,n2,vv); 
    printf("%s\n",u1);
    j=expt;
    sprintf(u2,"SkyAdu%7.1f%6.1f See%4.1f ExpT %d",sky,sig,see,j);
    if(ia8)sprintf(u3,"Center:%s%s 2000.",c1,c2);
    else   sprintf(u3,"Center:");
    gg=13.;
l06:
    for(i=0;i<m1*m2;i++){ x=aa[i];
      x*=gg/sig; x+=99.; 
      if(x<0.)x=0.; if(x>255.)x=255.; a[i]=x;
    }
    x=m1; y=m2+i36; is=0; lm=le+mi;
    if(m3){ if(m3!=m1)jfend(1); else jfend(0); }
    jfbgft(200,235,255,  0,0,0);                 // set BG, front color RGB
    jfbegin("",m1,m2+i36,5);                      // "" means no file out
    jfenv(0.,x,0.,y,0);                          // frame define

    jfloadmap(a,m1,m2,0,0, 0,0);                 // show map
    if(ia8)direct(lm);
    jfsci(1); jfstext(1);  jftext(260.,m2+125.,u1);  
              jfstext(-1); jftext(260.,m2+105.,u2); 
                           jftext(260.,m2+ 90.,u3);
    jflush();
    k=ip;  m3=m1;
//    fflush(stdin); //fflush(stdout);
  oldi=oldj=0;
l99:
  jfcursor(&i,&j,&c);
  if(i<0 || i >m1 || j<0 || j >m2)goto l99;
  if(i!=oldi || j!=oldj){ oldi=i; oldj=j;
    getstat(i,j,vv,le,mi);
    jfsci(0); jftext(260.,m2+15.,v8);
    jfsci(4); jftext(260.,m2+15.,u8);  strcpy(v8,u8);
    s_map();
  }
  if(c=='g'){ 
    printf("%s",u1);
    sprintf(jf_name,"jzfits%d.gif",ip);
    jf_gif(); goto l99;
  }
  if(c=='h'){ help(); goto l99; }
  if(c=='+' || c==4 || c=='u'){ gg+=2.;  goto l06; }
  if(c=='-' || c==5 || c=='d'){ gg-=2.;  goto l06; }
//  if(c=='l'){ turn90(aa,&m1,&m2); le++;    le%=4;   goto l06; }
if(c=='l'){  printf("%d\n",tt[itt]);
   for(i=0;i<n1*n2;i++)b2[i]=bb[i];
  turnx2_(b2,&n1,&n2,&tt[itt++]);
   for(i=0;i<n1*n2;i++)b[i]=b2[i];

    goto l051; }
  if(c=='m'){ mirror(aa,&m1,&m2); le=4-le; le%=4; mi=4-mi; goto l06; }
  if(c=='e' || c=='q' ||  c==27){ jfend(0); fflush(stdin); exit(0); }
  if(c=='b' || c==2 ){ if(i==oi && j==oj)goto l99; else { ip--; oi=i; oj=j; }} 
  if(c==13  || c==3 )if(i>0 && i<m1 && j>0 && j<m2) ip++;
  if(c=='c' || c==1 ){ if(i==oi && j==oj)goto l99;
            jfsci(0);  jftext(260.,m2+75.,v4);
                       jftext(260.,m2+60.,v5);
                       jftext(260.,m2+45.,v6);
            x=i; y=j+12; oi=i; oj=j;
            is++;  sprintf(c4,"%2d",is);  
            jfsci(3);  jftext(x,y,c4);
            pickup();         jftext(260.,m2+75.,u4); strcpy(v4,u4);
            if(U4){ jfsci(4); jftext(260.,m2+60.,u5); strcpy(v5,u5); }
            if(SL){ jfsci(5); jftext(260.,m2+45.,u6); strcpy(v6,u6); }
            goto l99;
          }
  if(c=='n'){ printf(" inputs nnn: "); scanf("%d",&ip); }
  if(ip<1){ beep(); ip=1; }
  if(ip>=ac){ beep(); ip=ac-1; }
  if(k==ip)goto l99; 
  jfsci(0); jfstext(1);  jftext(260.,m2+125.,u1);                // clear
            jfstext(-1); jftext(260.,m2+105.,u2);
                         jftext(260.,m2+ 90.,u3);
                         jftext(260.,m2+ 75.,u4);
                         jftext(260.,m2+ 60.,u5);
                         jftext(260.,m2+ 45.,u6);
  goto loop; 
}

s_map()
{
  float x; int i,j,k,ix,iy;
  unsigned char m;
  m=0; if(gg<0)m=255;
  ix=X; iy=Y; k=0;
  for(j=iy-63;j<=iy+63;j++)for(i=ix-63;i<=ix+63;i++){
    if(i>=0 && i<n1 && j>=0 && j<n2)x=b[j*n1+i]-sky; else x=32767.;
    dd[k++]=x;
  }
  for(i=0;i<127*127;i++){ x=dd[i]*gg/sig; x+=99.; 
    if(x<0.)x=0.; if(x>255.)x=255.; d[i]=x; }
//  d[8064-126]=d[8064-128]=d[8064]=d[8064+126]=d[8064+128]=m; 
  jfloadmap(d,127,127,0,m2+3,0,0);
  jfsci(3); jflp(18); jfpoint(63.,m2+66.);  
}

pickup()
{
  float x,y,z;
  int ix,iy;
  int i,j,k;
  k=center(X,Y,&x,&y);
  if(k){
    ix=x+0.5; iy=y+0.5;
    center(ix,iy,&x,&y);
  }
  if(it)printf("%d %d --> %6.1f %6.1f\n",X,Y,x,y);
entry:                           // fixed X,Y;
  ix=x+0.5; iy=y+0.5; k=0;
  for(j=iy-63;j<=iy+63;j++)for(i=ix-63;i<=ix+63;i++){
    if(i>=0 && i<n1 && j>=0 && j<n2)z=b[j*n1+i]-sky; else z=32767.;
    dd[k++]=z;
  }
  for(i=0;i<127*127;i++){ z=dd[i];
    z*=gg/sig; z+=99.; 
    if(z<0.)z=0.; if(z>255.)z=255.; d[i]=z;
  }
  jfloadmap(d,127,127,129,m2+3,0,0);
  jfsci(2); jflp(18); jfpoint(63.+129.,m2+66.);  
  xx=x; yy=y; 
  xy_rad(a8[6],a8[7],xx,yy,&a1,&d1,type,0);
  toms2(a1,c1,1); toms2(d1,c2,0); c1[12]=c2[11]=0;
  sprintf(u4,"%d:%7.1f%7.1f%s%s",is,x,y,c1,c2);
  printf("  %s\n",u4);
  sprintf(t,"u4%s %s 5 jzfits.u4",c1,c2);
  system(t);
  sprintf(t,"dr10psf %s %s 1 23 0 >jfits.sl",c1,c2);
  system(t);
}

int center(ix,iy,x,y)
int ix,iy; float *x,*y;
{
  float d[40],s,z; int i,j,k,i5=vv,bi,by,bs;
  int ix1,ix2,iy1,iy2;
  ix1=ix-i5; if(ix1<0)ix1=0;
  ix2=ix+i5; if(ix2>=n1)ix2=n1-1;
  iy1=iy-i5; if(iy1<0)iy1=0;
  iy2=iy+i5; if(iy2>=n2)iy2=n2-1;
  for(i=ix1,k=0;i<=ix2;i++){ z=0.;
    for(j=iy1;j<=iy2;j++)z+=b[j*n1+i]-sky;
    d[k++]=z;
  }
  z=s=0; for(i=ix1,k=0;i<=ix2;i++,k++){ z+=d[k]; s+=d[k]*i; }
  if(z!=0)*x=s/z; else *x=ix;
  for(j=iy1,k=0;j<=iy2;j++){ z=0.;
    for(i=ix1;i<=ix2;i++)z+=b[j*n1+i]-sky;
    d[k++]=z;
  }
  z=s=0; for(j=iy1,k=0;j<=iy2;j++,k++){ z+=d[k]; s+=d[k]*j; }
  if(z!=0)*y=s/z; else *y=iy;
// jduge:  pick bright pixel;
  bs=0.;
  for(j=iy1;j<=iy2;j++)for(i=ix1;i<=ix2;i++){ 
    s=b[j*n1+i];
    if(s>bs){ bs=s; bi=i; by=j; }
  } 
  s=(*x-ix); z=(*y-iy);
  if((s*s+z*z)>vv*vv)goto l99; 
  j=*y+0.5; i=*x+0.5;
  s=b[j*n1+i]-sky;
  if(s<=0.)goto l99;
  bs-=sky;
  if(bs<3*sig)return(0);        // as input x,y
  if(bs/s>1.1)goto l99;         // if there is bright spot
  return(1);
l99:
  *x=bi; *y=by;
  return(0);
}                        

getstat(i,j,vv,le,mi)
int i,j,vv,le,mi;
{
  int x,y;
  lm=le+mi; x=i*vv; y=j*vv;
  m0=(m1-m2)*vv;
  if(lm==0){ X=x;    Y=y;    }
  if(lm==1){ X=y;    Y=n1-x+m0; }  // i: +m0; }
  if(lm==2){ X=n1-x; Y=n2-y; }
  if(lm==3){ X=n2-y-m0; Y=x;    }  // j: -m0
  if(lm==4){ X=n1-x; Y=y;    }
  if(lm==5){ X=n2-y-m0; Y=n1-x+m0; }
  if(lm==6){ X=x;    Y=n2-y; }
  if(lm==7){ X=y;    Y=x;    }
  if(it)printf("lm: %d  i: %d  j: %d\n",lm,i,j);
  if(ia8==0) sprintf(u8,"%4d %4d",X,Y);
  else {
    xx=X; yy=Y;
    xy_rad(a8[6],a8[7],xx,yy,&a1,&d1,type,0);
    toms2(a1,c1,1); c1[11]=0; toms2(d1,c2,0); c2[9]=0;
    sprintf(u8,"%4d%5d%8.1f%s%s",X,Y,b[Y*n1+X],c1,c2);
  }
}

turn90(a,m1,m2)
float *a; int *m1,*m2;
{
  int i,j,k,u,v;
  u=*m1; v=*m2;
  for(j=0;j<v;j++)for(i=0;i<u;i++)ab[(i+1)*v-1-j]=a[j*u+i];
  for(i=0;i<u*v;i++)a[i]=ab[i];
  *m1=v; *m2=u;
}

mirror(a,m1,m2)
float *a; int *m1,*m2;
{
  int i,j,k,u,v;
  u=*m1; v=*m2;
  for(j=0;j<v;j++)for(i=0;i<u;i++)ab[(j+1)*u-1-i]=a[j*u+i];
  for(i=0;i<u*v;i++)a[i]=ab[i];
}

beep() { char c=7; printf("%c",c); fflush(stdin); }

help()
{
  char c37=37;
  printf("\n\t Usage: jfits  *.fit [%csize] [!]\n",c37);
  printf("\n\t Ex. jfits /BATC/smt4/P1079/*/*.fit");
  printf("\n\t     jfits /BATC/smt2/r0001/*/*.fit");
  printf("\n\t     jfits /line6/cat/101103/p*_1.fit");
  printf("\n\t     jfits /vega2/rhbin/n2175.fit %c800\n",c37);
  printf("\n\t %csize self define frame size <1250pixel",c37);
  printf("\n\t ! print more");
  printf("\n\t if detail, pls look jzfits.txt (in chinese)\n");
  printf("\n\tmouse operating: (cursor inside frame)\n");
  printf("\n\t left_key <c>        pick_star         l       left_ 90degree");
  printf("\n\tright_key (cr>         forward         m         mirror image");
  printf("\n\t  mid_key (b)         backward         g              out_gif");
  printf("\n\t  mid_key_up(+)(u)     up_grey         h                 help");
  printf("\n\t  mid_key_down(-)(d) down_grey         n       input  nth_pic");
  printf("\n\t  (e)(q)<esc>             exit         (need input on console)\n\n");
}

sortx1(a,n)
float *a; int n;
{
  int i,j,k=2,ii,ifin;
  float x;
  while(k<n)k*=2;
  k=(3*k)/4-1; if(n<k)k=n;
l20:
  k/=2;        ifin=n-k;
  for(ii=0;ii<ifin;ii++){
    i=ii;      j=i+k;
    if(a[i]<=a[j])continue;
    x = a[j];
l40:
    a[j]= a[i];
    j=i;       i-=k;
    if(i<0)goto l60;
    if(a[i]>x)goto l40;
l60:
    a[j]=x;
  }
  if(k>1)goto l20;
}

#define MINSKY    20
iraf_sky(bb,i1,i2,skymod,skysig)
int i1,i2; float *bb,*skymod,*skysig;
{
  int   dnsky=i2;
  float hibad=32000.;
  float readns=.0;
  float dskymn,dskymed,dskymod,dsigma,dskew;
  mmm(bb,&dnsky, hibad, readns,&dskymn,&dskymed,&dskymod,&dsigma,&dskew);
  *skymod=dskymod;
  *skysig=dsigma;
}

mmm(sky,dnsky,hibad,readns, dskymn,dskymed,dskymod,dsigma,dskew)
float sky[];
int   *dnsky;
float hibad, readns;
float *dskymn,*dskymed,*dskymod,*dsigma,*dskew;
{
  double sum,sumsq;
  float  skymn, skymed, skymod, sigma;
  float  cut,cut1,cut2,delta,skymid,r,center,side,dmod,old,clamp;
  int    i,j,k,l,m,minimm,maximm,niter,istep,maxit,jstep,nsky;
  char   redo;

  nsky=*dnsky;
  maxit=30;                      // itet times
  if(nsky <= 0)goto l9900;
  skymid=0.5*(sky[(nsky-1)/2]+sky[nsky/2]);
  sum=0.;
  sumsq=0.;
  cut1=skymid-sky[0];
  if(cut1> sky[nsky-1]-skymid)cut1=sky[nsky-1]-skymid;
  if(cut1> hibad-skymid)cut1=hibad-skymid;
  cut2=skymid + cut1;
  cut1=skymid - cut1;
  minimm=0;
  for(i=1;i<=nsky;i++){                // 1010
    if(sky[i-1] < cut1){ minimm=i; continue; }
    if(sky[i-1] > cut2)goto l1020;
    delta=sky[i-1]-skymid;
    sum+=delta;
    sumsq+=delta*delta;
    maximm=i;
  }
l1020:
  skymed=0.5*(sky[(minimm+maximm-1)/2]+sky[(minimm+maximm)/2]);
  skymn=sum/(maximm-minimm);
  sigma=sqrt(sumsq/(maximm-minimm)-skymn*skymn);
  skymn+=skymid;
  skymod=skymn;
  if(skymed < skymn) skymod=3.*skymed-2.*skymn;

  niter= 0;
  old  = 0.;
  clamp= 1.;
l2000:
  niter++;
  if( (niter > maxit) || (maximm-minimm < MINSKY)) goto l9900;
  r=log10((float)(maximm-minimm));
  r= (-.1042*r+1.1695)*r+.8895;
  if(r<2.)r=2.;
  cut= r*sigma+0.5*abs(skymn-skymod);
  if(cut<1.5)cut=1.5;
  cut1=skymod-cut;
  cut2=skymod+cut;
  redo=0;
  istep=1; if(cut1-sky[minimm]<0.)istep=-1;
  jstep=(istep+1)/2;
  if (istep > 0)goto  l2120;
l2100:
  if ((istep < 0) && (minimm <= 0))goto  l2150;
  if((sky[minimm-1] <= cut1) && (sky[minimm] >= cut1))goto l2150;
l2120:
  delta=sky[minimm+jstep-1]-skymid;
  sum-=istep*delta;
  sumsq-=istep*delta*delta;
  minimm+=istep;
  redo=1;
  goto l2100;
l2150:
  istep=1; if(cut2-sky[maximm-1]<0.)istep=-1;
  jstep=(istep+1)/2;
  if(istep < 0)goto  l2220;
l2200:
  if((istep > 0) && (maximm >= nsky))goto l2250;
  if((sky[maximm-1] <= cut2) && (sky[maximm] >= cut2))goto l2250;
l2220:
  delta=sky[maximm+jstep-1]-skymid;
  sum+=istep*delta;
  sumsq+=istep*delta*delta;
  maximm+=istep;
  redo=1;
  goto l2200;
l2250:
  skymn=sum/(maximm-minimm);
  sigma=sqrt(sumsq/(maximm-minimm)-skymn*skymn);
  skymn+=skymid;
  skymed=0.;
  center = (minimm+1 + maximm)/2.;
  j= nint(0.2*(maximm-minimm));
  side = j/2. + 0.25;
  j = nint(center-side);
  k = nint(center+side);
  l = nint(center-0.25);
  m = nint(center+0.25);
  r = 0.25*readns;
l2305:
  if((j>1)&&(k<nsky)&&((sky[l-1]-sky[j-1]<r)||(sky[k-1]-sky[m-1]<r))){
    j--;    k++;    goto l2305;
  }
  for(i=j;i<=k;i++) skymed+=sky[i-1];
  skymed/=(k-j+1);
  if(skymed < skymn) dmod=3.*skymed-2.*skymn - skymod;
  else dmod=skymn - skymod;
  if (dmod*old < 0.) clamp = 0.5*clamp;
  skymod += clamp*dmod;
  old = dmod ;
  if (redo)goto  l2000;
  if(sigma<1.)sigma=1.;
  *dskew=(skymn-skymod)/sigma;
  *dnsky=maximm-minimm;
  *dskymn=skymn;
  *dskymed=skymed;
  *dskymod=skymod;
  *dsigma=sigma;
  return;
l9900:
  *dsigma=-1.0;
  *dskew=0.0;
  return;
}

getsky(a,n1,pixelx,pixely,sky,sig)
float *a,*sky,*sig; int n1,pixelx,pixely;
{
  float x,z,b[2025];
  int i,j,ii,jj,k=0;
  int i180,i8;
  i180=180; i8=8;
  if(n1<512){ i180=90; i8=4; }
  for(jj=pixely-i180;jj<pixely+i180;jj+=i8)
  for(ii=pixelx-i180;ii<pixelx+i180;ii+=i8){
    x=0.; for(j=jj;j<jj+i8;j++)for(i=ii;i<ii+i8;i++)x+=a[j*n1+i]; 
    if(x!=0.)b[k++]=x/(i8*i8);
  }
  sortx1(b,k);          // take  0.1~0.5 segement
  iraf_sky(b,1,k,sky,sig);
}

xytoad(x,a)
double *x,*a;
{
  double z;
  z=x[0]*x[3]-x[2]*x[1];
  a[0]= x[3]/z;
  a[1]=-x[1]/z;
  a[2]=-x[2]/z;
  a[3]= x[0]/z;
  a[4]= (x[2]*x[5]-x[4]*x[3])/z;
  a[5]= (x[4]*x[1]-x[0]*x[5])/z;
}

#define bok  48.
xy_rad(ac,dc,x,y,ra,de,type,k)
double ac,dc,x,y,*ra,*de;  int type,k;
{
  double xi,xn,tmp,tmp1;
  double x1,y1,r1,d1;
  int i;
  xi=a8[0]*x+a8[2]*y+a8[4];
  xn=a8[1]*x+a8[3]*y+a8[5];
  if(type==1){
    tmp=sqrt(xi*xi+xn*xn);
    if(tmp!=0.){
      tmp=tan(tmp)/tmp;
      xi*=tmp;  xn*=tmp;
    }
  }
  if(type==2){
    tmp=1.+bok*(xi*xi+xn*xn);

    for(i=0;i<4;i++){
      x1=xi/tmp; y1=xn/tmp;
      tmp=tan(dc);  tmp1=1.-y1*tmp;
      r1=atan(x1/cos(dc)/tmp1);
      d1=atan((y1+tmp)*cos(r1)/tmp1);
      r1+=ac;
      tmp=atan(tan(d1)/cos(r1-ac));
      x1=cos(tmp)*tan(r1-ac)/cos(tmp-dc);
      y1=tan(tmp-dc);
      tmp=1.+bok*(x1*x1+y1*y1);
    }
    xi/=tmp; xn/=tmp;
  }
  tmp=tan(dc);  tmp1=1.-xn*tmp;
  *ra=atan(xi/cos(dc)/tmp1);
  *de=atan((xn+tmp)*cos(*ra)/tmp1);
  *ra+=ac;
  tmp=(*de)-dc; if(tmp<0.)tmp=-tmp;
  if(tmp>2.){  *de=-(*de);  *ra+=pi; }
  if(*ra<0.)*ra+=(pi+pi);
  if(k==0){ *ra/=cx; *de/=cy; }
}

turnx2(a,n1,n2,it)                        // for 2048*2048 smt2 ccd only
float *a; int *n1,*n2,it;
{
  float *b; int i,j,k,u,v,n;
  k=it/90; if(k==0 || k>3)return; 
  u=*n1; v=*n2; n=u*v; b=(float *)a+n;
  for(i=0;i<n;i++)b[i]=a[i];  if(k<0)k=4-k; if(k==8)k==4;
  if(k==1)for(i=k=0;i<u;i++)for(j=0;j<v;j++)a[k++]=b[(j+1)*u-1-i];
  if(k==2)for(i=0;i<n;i++)a[i]=b[n-1-i];
  if(k==3)for(j=k=0;j<v;j++)for(i=0;i<u;i++)a[(i+1)*v-1-j]=b[k++];
  if(k==4)for(j=k=0;j<v;j++)for(i=0;i<u;i++)a[k++]=b[(j+1)*u-1-i];
  if(k==5)for(i=k=0;i<u;i++)for(j=0;j<v;j++)a[k++]=b[(j+1)*u-1-i];
  if(k==6)for(j=k=0;j<v;j++)for(i=0;i<u;i++)a[k++]=b[(v-1-j)*u+i];
  if(k==7)for(i=k=0;i<u;i++)for(j=0;j<v;j++)a[k++]=b[(v-j)*u-1-i];
  if(k%2==1){ k=*n1; *n1=*n2; *n2=k; }
}  

direct(lm)
int lm;
{
  float x,y;
  x=m1/2.; y=m2/2.;
  if(lm==0){ jfsci(3); jflp(-19); jfpoint(x,y+8); 
             jfsci(2); jflp(-18); jfpoint(x-8,y); }
  if(lm==1){ jfsci(3); jflp(-18); jfpoint(x-8,y); 
             jfsci(2); jflp(-20); jfpoint(x,y-8); }
  if(lm==2){ jfsci(3); jflp(-20); jfpoint(x,y-8);
             jfsci(2); jflp(-17); jfpoint(x+8,y); }
  if(lm==3){ jfsci(3); jflp(-17); jfpoint(x+8,y); 
             jfsci(2); jflp(-19); jfpoint(x,y+8); }

  if(lm==4){ jfsci(3); jflp(-19); jfpoint(x,y+8); 
             jfsci(2); jflp(-17); jfpoint(x+8,y); }
  if(lm==5){ jfsci(3); jflp(-18); jfpoint(x-8,y); 
             jfsci(2); jflp(-19); jfpoint(x,y+8); }
  if(lm==6){ jfsci(3); jflp(-20); jfpoint(x,y-8);
             jfsci(2); jflp(-18); jfpoint(x-8,y); }
  if(lm==7){ jfsci(3); jflp(-17); jfpoint(x+8,y); 
             jfsci(2); jflp(-20); jfpoint(x,y-8); }
} 
